IS_SAO_SYSTEM = "SAO:System"

list_of_DSO = ["DSO", "DSO-AOCS", "DSO-AOCS-instances"]


'''Return the Systems from the Ontologies'''
def get_keyword(keyword):
    system_list = []
    with open("../../Ontologies/Mokos_18_1_7_47.ttl") as f:
        for dso in list_of_DSO :
            flag_1, flag_2 = 0, 0
            for line in f:
                if line.startswith(dso): 
                    spliter_1 = line.split(':')
                    spliter_2 = spliter_1[1].split(' ')
                    key = spliter_2[0].strip()
                    flag_1 = 1
                if flag_1 == 1: 
                    if ':' in keyword:   
                        if keyword in line and "subClassOf" in line:
                            flag_2 = 1
                    elif not ':' in keyword:
                         keyword = ':'+keyword 
                         if keyword in line and "subClassOf" in line:
                            flag_2 = 1
                if flag_1 == 1 and flag_2 == 1:
                    if (line.strip()).endswith('.'):
                        if not key in system_list:
                            system_list.append(key)
                        flag_1, flag_2 = 0, 0
                if (line.strip()).endswith('.') and not ((line.strip()).startswith('-') or (line.strip()).startswith('rdfs:comment')) :
                    flag_1, flag_2 = 0, 0  
        return system_list


def find_extra_keywords(keyword):
    first_search = get_keyword(keyword)
    second_search = first_search.copy()
    for i in first_search:
        k = get_keyword(i)
        for kl in k:
            if not kl in second_search:
                second_search.append(kl)
    third_search = second_search.copy()
    for i in second_search:
        k = get_keyword(i)
        for kl in k:
            if not kl in third_search:
                third_search.append(kl)
    return tuple((str(n), str(n)) for n in third_search)